<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8" />
    <title>Type Ahead 👀</title>
    <link rel="stylesheet" href="style.css" />
    <link rel="icon" href="https://fav.farm/🔥" />
  </head>
  <body>
    <form class="search-form">
      <input type="text" class="search" placeholder="City or State" />
      <ul class="suggestions">
        <li>Filter for a city</li>
        <li>or a state</li>
      </ul>
    </form>
    <script>
      const endpoint =
        "https://gist.githubusercontent.com/Miserlou/c5cd8364bf9b2420bb29/raw/2bf258763cdddd704f8ffd3ea9a3e81d25e2c6f6/cities.json";

      const cities = [];

      //   const address = [];

      fetch(endpoint)
        .then((blob) => blob.json())
        .then((data) => {
          cities.push(...data);
          //   address.push(...data);
        });

      console.log(cities);
      // console.log(address);

      // function for finding match(cities, state)
      function findMatches(wordTowatch, cities) {
        return cities.filter((place) => {
          // regex for matching
          const regex = new RegExp(wordTowatch, "gi");

          return place.city.match(regex) || place.state.match(regex);
        });
      }

      // function for 
      function numberWithCommas(x) {
        return x.toString().replace(/\B(?=(\d{3})+(?!\d))/g, ",");
      }

      // function for displaying matched data

      function displayMatches() {
        const matchArray = findMatches(this.value, cities);
        console.log(matchArray);
        const placesdata = matchArray
          .map((place) => {
            const regex = new RegExp(this.value, "gi");
            const cityName = place.city.replace(
              regex,
              `<span class="hl">${this.value}</span>`
            );

            const stateName = place.state.replace(
              regex,
              `<span class="hl">${this.value}</span>`
            );

            return `
                    <li>
                        <span classname ="name">${cityName}, ${stateName}</span>
                        <span classname ="population">${numberWithCommas(place.population)}</span>
                    </li>
                `;
          })
          .join("");

        suggestions.innerHTML = placesdata;
      }

      // DOM Manipulation
      const searchText = document.querySelector(".search");
      const suggestions = document.querySelector(".suggestions");

      //   console.log(searchText);
      // added 2 eventlistener's (change (it will work when it search something and go outside of textbox), keyup(on key press))
      searchText.addEventListener("change", displayMatches);
      searchText.addEventListener("keyup", displayMatches);
    </script>
  </body>
</html>
